unit DbAdrViewFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Spin, StdCtrls, Buttons,
  ExtCtrls, DBCtrls, Mask, DBCGrids;

type
  TDbAdrViewForm = class(TForm)
    DBNavigator1: TDBNavigator;
    CloseBitBtn: TBitBtn;
    HelpBitBtn: TBitBtn;
    DisconnectBtn: TBitBtn;
    PrintBtn: TBitBtn;
    ConnectBtn: TBitBtn;
    LabelBtn: TBitBtn;
    DBEdit11: TDBEdit;
    Label11: TLabel;
    DBEdit12: TDBEdit;
    Label12: TLabel;
    DBCheckBox3: TDBCheckBox;
    DBCheckBox4: TDBCheckBox;
    DBEdit13: TDBEdit;
    Label13: TLabel;
    DBEdit14: TDBEdit;
    Label14: TLabel;
    DBEdit15: TDBEdit;
    Label15: TLabel;
    DBEdit16: TDBEdit;
    Label16: TLabel;
    DBEdit17: TDBEdit;
    DBEdit18: TDBEdit;
    Label18: TLabel;
    DBEdit19: TDBEdit;
    Label19: TLabel;
    DBEdit20: TDBEdit;
    Label20: TLabel;
    DatabaseSaveBitBtn: TBitBtn;
    AddressRadioGroup: TRadioGroup;
    NamebyRG: TRadioGroup;
    ImgLabelBtn: TBitBtn;
    ImgLabel30Btn: TBitBtn;
    BigLabelsCB: TCheckBox;
    DBImage2: TDBImage;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    DBNavigator2: TDBNavigator;
    DBEdit2: TDBEdit;
    ImageConnectionBtn: TBitBtn;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    Label3: TLabel;
    DBEdit6: TDBEdit;
    Label4: TLabel;
    DBEdit7: TDBEdit;
    AddAddressBtn: TBitBtn;
    EmailBtn: TSpeedButton;
    DBCheckBox1: TDBCheckBox;
    FamilyLinkerBtn: TSpeedButton;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    DBEdit10: TDBEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    KeyedCB: TCheckBox;
    DBCheckBox2: TDBCheckBox;
    DBCheckBox5: TDBCheckBox;
    DBCheckBox6: TDBCheckBox;
    DBEdit21: TDBEdit;
    Label2: TLabel;
    Label5: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CloseBitBtnClick(Sender: TObject);
    procedure HelpBitBtnClick(Sender: TObject);
    procedure Select;
    procedure Disconnect;
    procedure DisconnectBtnClick(Sender: TObject);
    procedure ConnectBtnClick(Sender: TObject);
    procedure Connect;
    procedure DatabaseDo;
    procedure PrintBtnClick(Sender: TObject);
    procedure LabelBtnClick(Sender: TObject);
    procedure DatabaseSaveBitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImgLabelBtnClick(Sender: TObject);
    procedure ImgLabel30BtnClick(Sender: TObject);
procedure DatabaseDodo;
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure ImageConnectionBtnClick(Sender: TObject);
    procedure DBNavigator2Click(Sender: TObject; Button: TNavigateBtn);
    procedure FormDeactivate(Sender: TObject);
    procedure AddAddressBtnClick(Sender: TObject);
    procedure EmailBtnClick(Sender: TObject);
    procedure FamilyLinkerBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DbAdrViewForm: TDbAdrViewForm;

implementation

{$R *.DFM}
uses FmxUtils, ShellAPI,
     DbSessionFrm, DBAdrPrnForm,DBAdrLblForm,
     LoGlobals,DBAdrImgLblForm, DBBigAdrImgLblForm;


procedure TDbAdrViewForm.FormCreate(Sender: TObject);
begin
  {left := GoldFormX;
  top := GoldFormY;   }
  DBNavigator1.Enabled:=False;
end;

procedure TDbAdrViewForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
{  GoldFormX := DbAdrViewForm.left;
  GoldFormY := DbAdrViewForm.top;  }
  DbSessionForm.DataTable.Filtered := False;
  DbSessionForm.DataTable.Filter := '';
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.ImagTable.Filter := '';
  disconnect;
end;
procedure TDbAdrViewForm.FormDeactivate(Sender: TObject);
begin
  DbSessionForm.DataTable.Filtered :=False;
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.DataTable.Filter := '';
  DbSessionForm.ImagTable.Filter := '';
end;
procedure TDbAdrViewForm.CloseBitBtnClick(Sender: TObject);
begin
  DbSessionForm.ImagTable.Filtered := False;
  Close;
end;

procedure TDbAdrViewForm.HelpBitBtnClick(Sender: TObject);
begin
  {Get Help for Address Viewer}
  Application.HelpContext(9200); 
end;

procedure TDbAdrViewForm.Select;
var Which: Integer;
begin
  Which := AddressRadioGroup.ItemIndex;
  case Which of
    0..1: begin
        DbSessionForm.DataTable.Filtered := False;
        DbSessionForm.DataTable.Filter := '';
      end;
    2: begin
        DbSessionForm.DataTable.Filter := 'Sent';
        DbSessionForm.DataTable.Filtered := True;
      end;
    3: begin
        DbSessionForm.DataTable.Filter := 'Rcvd';
        DbSessionForm.DataTable.Filtered := True;
      end;
  end;
end;


procedure TDbAdrViewForm.DisconnectBtnClick(Sender: TObject);
begin
  disconnect;
  DBNavigator2.Enabled:=True;
  DBNavigator1.Enabled:=False;
  DbSessionForm.ImagTable.Filtered := False;
end;

procedure TDbAdrViewForm.Disconnect;
begin
  DbSessionForm.ImagTable.Active := False;
  DbSessionForm.LinkTable.Active := False;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.AdrTable.Active := False;
  DbSessionForm.ImagTable.MasterSource := nil;
  DbSessionForm.ImagTable.MasterFields := '';
  DbSessionForm.ImagTable.IndexFieldNames := '';
  DbSessionForm.LinkTable.MasterSource := nil;
  DbSessionForm.LinkTable.MasterFields := '';
  DbSessionForm.LinkTable.IndexFieldNames := '';
  DbSessionForm.DataTable.MasterSource := nil;
  DbSessionForm.DataTable.MasterFields := '';
  DbSessionForm.DataTable.IndexName := '';
  DbSessionForm.AdrTable.MasterSource := nil; {2}
  DbSessionForm.AdrTable.MasterFields := ''; {AddLink}
  DbSessionForm.AdrTable.IndexFieldNames := ''; {AddLink}
  DbSessionForm.AdrTable.Active := True;
  DbSessionForm.ImagTable.Active := True;
  DbSessionForm.LinkTable.Active := True;
  DbSessionForm.DataTable.Active := True;
end;


procedure TDbAdrViewForm.ConnectBtnClick(Sender: TObject);
begin
  connect;
  DBNavigator2.Enabled:=False;
  DBNavigator1.Enabled:=True;
  DbSessionForm.ImagTable.Filtered := False;
end;

procedure TDbAdrViewForm.Connect;
begin
  DbSessionForm.AdrTable.Active := False;
  DbSessionForm.ImagTable.Active := False;
  DbSessionForm.LinkTable.Active := False;
  DbSessionForm.DataTable.Active := False;

  DbSessionForm.DataTable.MasterSource := nil;
  DbSessionForm.DataTable.MasterFields := '';
  DbSessionForm.DataTable.IndexName := '';
  DbSessionForm.ImagTable.MasterSource :=DbSessionForm.AdrDS;{ HoloForm.LinkDS;}
  DbSessionForm.ImagTable.MasterFields := 'ImageLink';
  DbSessionForm.ImagTable.IndexFieldNames := 'ImageLink';
{  DbSessionForm.ImagTable.MasterSource := nil;
  DbSessionForm.ImagTable.MasterFields := '';
  DbSessionForm.ImagTable.IndexFieldNames := '';}
{  DbSessionForm.LinkTable.MasterSource := nil;
  DbSessionForm.LinkTable.MasterFields := '';
  DbSessionForm.LinkTable.IndexName := '';}
  DbSessionForm.LinkTable.MasterSource := DbSessionForm.DataDS;
  DbSessionForm.LinkTable.MasterFields := 'FamilyLink';
  DbSessionForm.LinkTable.IndexName := 'FLink';
  DbSessionForm.AdrTable.MasterSource := DbSessionForm.DataDS; {2}
  DbSessionForm.AdrTable.MasterFields := 'AddLink'; {AddLink}
  DbSessionForm.AdrTable.IndexFieldNames := 'AddLink'; {AddLink}
  DbSessionForm.LinkTable.Active := True;
  DbSessionForm.DataTable.Active := True;
  DbSessionForm.AdrTable.Active := True;
  DbSessionForm.ImagTable.Active := True;
end;

procedure TDbAdrViewForm.FamilyLinkerBtnClick(Sender: TObject);
begin
{Change DataDS Link to Family-Parent}
  DBNavigator1.Enabled:=True;
  DBNavigator2.Enabled:=True;
  DbSessionForm.AdrTable.Active := False;
  DbSessionForm.ImagTable.Active := False;
  DbSessionForm.LinkTable.Active := False;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.DataTable.Filtered := False;
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.DataTable.MasterSource := nil;
  DbSessionForm.DataTable.MasterFields := '';
  DbSessionForm.DataTable.IndexName := 'PLink';
  DbSessionForm.LinkTable.MasterSource := DbSessionForm.DataDS;
  DbSessionForm.LinkTable.MasterFields := 'FamilyLink';
  DbSessionForm.LinkTable.IndexName := 'FLink';
  {LinkDS;}
{  DbSessionForm.ImagTable.MasterSource := DbSessionForm.AdrDS;
  DbSessionForm.ImagTable.MasterFields := 'ImageLink';
  DbSessionForm.ImagTable.IndexFieldNames := 'ImageLink';}
  DbSessionForm.ImagTable.MasterSource := nil;
  DbSessionForm.ImagTable.MasterFields := '';
  DbSessionForm.ImagTable.IndexFieldNames := '';
  DbSessionForm.AdrTable.MasterSource := DbSessionForm.DataDS; {2}
  DbSessionForm.AdrTable.MasterFields := 'AddLink'; {AddLink}
  DbSessionForm.AdrTable.IndexFieldNames := 'AddLink'; {AddLink}

  DbSessionForm.DataTable.Active := True;
  DbSessionForm.LinkTable.Active := True;
  DbSessionForm.ImagTable.Active := True;
  DbSessionForm.AdrTable.Active := True;
end;

procedure TDbAdrViewForm.ImageConnectionBtnClick(Sender: TObject);
begin
  DBNavigator1.Enabled:=True;
  DBNavigator2.Enabled:=True;
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.AdrTable.Active := False;
  DbSessionForm.ImagTable.Active := False;
  DbSessionForm.LinkTable.Active := False;
  DbSessionForm.DataTable.Active := False;

  DbSessionForm.DataTable.MasterSource := nil;
  DbSessionForm.DataTable.MasterFields := '';
  DbSessionForm.DataTable.IndexName := '';
{  DbSessionForm.LinkTable.MasterSource := nil;
  DbSessionForm.LinkTable.MasterFields := '';
  DbSessionForm.LinkTable.IndexName := '';}
  DbSessionForm.LinkTable.MasterSource := DbSessionForm.DataDS;
  DbSessionForm.LinkTable.MasterFields := 'FamilyLink';
  DbSessionForm.LinkTable.IndexName := 'FLink';
 (* DbSessionForm.ImagTable.MasterSource := {DbSessionForm.AdrDS;} {HoloForm.LinkDS;}
  DbSessionForm.ImagTable.MasterFields := 'ImageLink';
  DbSessionForm.ImagTable.IndexFieldNames := 'ImageLink'; *)
  DbSessionForm.ImagTable.MasterSource := nil;
  DbSessionForm.ImagTable.MasterFields := '';
  DbSessionForm.ImagTable.IndexFieldNames := '';
  DbSessionForm.AdrTable.MasterSource := DbSessionForm.DataDS; {2}
  DbSessionForm.AdrTable.MasterFields := 'AddLink'; {AddLink}
  DbSessionForm.AdrTable.IndexFieldNames := 'AddLink'; {AddLink}
  DbSessionForm.LinkTable.Active := True;
  DbSessionForm.DataTable.Active := True;
  DbSessionForm.AdrTable.Active := True;
  DbSessionForm.ImagTable.Active := True;
end;

procedure TDbAdrViewForm.DBNavigator1Click(Sender: TObject;
  Button: TNavigateBtn);
{  var ImageInt:Integer;}
begin
  {Address Link selects the Image}
{  ImageInt:=HoloForm.AdrTableImageLink.Value;
        DbSessionForm.ImagTable.Filtered := False;
        DbSessionForm.ImagTable.Filter := 'ImageLink='+
                                     Inttostr(ImageInt);
  DbSessionForm.ImagTable.Filtered := True;}
end;

procedure TDbAdrViewForm.DBNavigator2Click(Sender: TObject;
  Button: TNavigateBtn);
begin
{  DbSessionForm.ImagTable.Filtered := False;}
end;

procedure TDbAdrViewForm.PrintBtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  DatabaseDo;
  DbAdrPrnForm.AdrPrnForm.QuickRep1.Preview; {: TAdrPrnForm}
  DbSessionForm.AdrSavedTable.Active := False;
end;

{2.625" wide 1.0 " height}
procedure TDbAdrViewForm.LabelBtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  DatabaseDo;
  DbAdrLblForm.AdrLblForm.QuickRep1.Preview;
  DbSessionForm.AdrSavedTable.Active := False;
end;

{2.625" wide 1.0 " height}
{4 x 2}
procedure TDbAdrViewForm.ImgLabelBtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  DatabaseDo;
  If BigLabelsCB.Checked then
  DbBigAdrImgLblForm.BigAdrImgLblForm.QuickRep1.Preview else
  DbAdrImgLblForm.AdrImgLblForm.QuickRep1.Preview;
  DbSessionForm.AdrSavedTable.Active := False;
end;


procedure TDbAdrViewForm.DatabaseSaveBitBtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  DatabaseDo;
  DbSessionForm.AdrSavedTable.Active := False;
end;

procedure TDbAdrViewForm.DatabaseDo;
var
{  ImageInt}i:Integer;
  Key,
  aFirstName,  LastName, FirstName,
  A, Address, City, State, Zip: string;
begin
  Connect;
  Select;
  {Empty old table data}
  DbSessionForm.AdrSavedTable.First;
  while (not DbSessionForm.AdrSavedTable.EOF) do
  begin
    DbSessionForm.AdrSavedTable.Delete;
  end;
  {Compile data for new Saved Table}
  DbSessionForm.DataTable.First;
  {HoloForm.AdrSavedTable.Active:=True;}
  i:=1;
  while (not DbSessionForm.DataTable.EOF) do
  begin
  if ((AddressRadioGroup.Itemindex=0)or
  ((not DbSessionForm.DataTableChild.Value)
   and(not DbSessionForm.DataTableDeceased.Value)
   and (not DbSessionForm.DataTableMarried.Value)))then
  begin
    LastName := DbSessionForm.DataTableLastName.Value;
    aFirstName := DbSessionForm.DataTableFirstName.Value;
    If NamebyRG.ItemIndex=0 then
         FirstName :=LastName+ ' ' +aFirstName
       else FirstName := aFirstName + ' ' + LastName;
    Key:= DbSessionForm.DataTableParentLink.AsString;
    If KeyedCB.Checked then FirstName :=Key+FirstName;
    A := DbSessionForm.AdrTableA.Value;
    Address := DbSessionForm.AdrTableAddress.Value;
    A := A + ' ' + Address;
    City := DbSessionForm.AdrTableCity.Value;
    State := DbSessionForm.AdrTableState.Value;
    Zip := DbSessionForm.AdrTableZip.Value;
    City := City + ' ' + State + ' ' + Zip;
{  ImageInt:=DbSessionForm.AdrTableImageLink.Value;
        DbSessionForm.ImagTable.Filtered := False;
        DbSessionForm.ImagTable.Filter := 'ImageLink='+
                                     Inttostr(ImageInt);
  DbSessionForm.ImagTable.Filtered := True;}
  inc(i);
    DbSessionForm.AdrSavedTable.AppendRecord(
           [Inttostr(I),FirstName, A, City,DbSessionForm.ImagTableBLOBIMAGE.Value]);
  end;
    DbSessionForm.DataTable.Next;
  end;
  DbSessionForm.DataTable.Filtered :=False;
  DbSessionForm.ImagTable.Filtered := False;
end;


procedure TDbAdrViewForm.ImgLabel30BtnClick(Sender: TObject);
begin
  DbSessionForm.AdrSavedTable.Active := True;
  DatabaseDodo;
  If BigLabelsCB.Checked then
  DbBigAdrImgLblForm.BigAdrImgLblForm.QuickRep1.Preview else
  DbAdrImgLblForm.AdrImgLblForm.QuickRep1.Preview;
  DbSessionForm.AdrSavedTable.Active := False;
end;


procedure TDbAdrViewForm.DatabaseDodo;
var
  ImageInt,I:Integer;
  aFirstName,  LastName, FirstName,
  A, Address, City, State, Zip: string;
begin
  {Select current}
  ImageInt := DbSessionForm.DataTableFamilyLink.Value;
  DbSessionForm.DataTable.Filter := 'FamilyLink='+Inttostr(ImageInt);
  DisConnect;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.DataTable.Filtered := True;
  DbSessionForm.ImagTable.Filtered := False;
  Connect;
  {Empty old table data}
  DbSessionForm.AdrSavedTable.First;
  while (not DbSessionForm.AdrSavedTable.EOF) do
  begin
    DbSessionForm.AdrSavedTable.Delete;
  end;
  {Compile data for new Saved Table}
    LastName := DbSessionForm.DataTableLastName.Value;
    aFirstName := DbSessionForm.DataTableFirstName.Value;
    If NamebyRG.ItemIndex=0 then
    FirstName :=LastName+ ' ' +aFirstName
    else FirstName := aFirstName + ' ' + LastName;
    A := DbSessionForm.AdrTableA.Value;
    Address := DbSessionForm.AdrTableAddress.Value;
    A := A + ' ' + Address;
    City := DbSessionForm.AdrTableCity.Value;
    State := DbSessionForm.AdrTableState.Value;
    Zip := DbSessionForm.AdrTableZip.Value;
    City := City + ' ' + State + ' ' + Zip;
{  ImageInt:=DbSessionForm.AdrTableImageLink.Value;
        DbSessionForm.ImagTable.Filtered := False;
        DbSessionForm.ImagTable.Filter := 'ImageLink='+
                                     Inttostr(ImageInt);
  DbSessionForm.ImagTable.Filtered := True;}
    For I:= 0 to 29 do
      DbSessionForm.AdrSavedTable.AppendRecord(
           [Inttostr(I),FirstName, A, City, DbSessionForm.ImagTableBLOBIMAGE.Value]);
    {DbSessionForm.AdrSavedTable.Active:=False;}
    DbSessionForm.DataTable.Filtered :=False;
    DbSessionForm.ImagTable.Filtered := False;
end;

{AddLink    I key
A#         A5
Address    A30
City       A20
State      A2
Zip       A10
ImageLink  I  Links Address to an Image
EMail    A30
Phone     A10
Born      A10
Died      A10}
procedure TDbAdrViewForm.AddAddressBtnClick(Sender: TObject);
var
  DataInt,LastOneI: Integer;
begin
  {Select current}
  DataInt := DbSessionForm.DataTableFamilyLink.Value;
  DbSessionForm.DataTable.Filter := 'FamilyLink='+Inttostr(DataInt);
  DisConnect;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.DataTable.Filtered := True;
  DbSessionForm.DataTable.Active := True;
  DbSessionForm.ImagTable.Filtered := False;
  DbSessionForm.AdrTable.Last;
  LastOneI := DbSessionForm.AdrTableAddLink.value;
  inc(LastOneI);
  DbSessionForm.AdrTable.AppendRecord([LastOneI]);
  DbSessionForm.DataTable.Edit;
  DbSessionForm.DataTableAddLink.Value := LastOneI;
  DbSessionForm.DataTable.Post;
  DbSessionForm.DataTable.Active := False;
  DbSessionForm.DataTable.Filter := '';
  DbSessionForm.DataTable.Filtered := False;
  DbSessionForm.ImagTable.Filtered := False;
  Connect;
  DbSessionForm.DataTable.Refresh;
End;

procedure TDbAdrViewForm.EmailBtnClick(Sender: TObject);
var Address:String;
begin
  Address := 'mailto:'+DbSessionForm.AdrTableEMail.AsString;
  ShellExecute(0, 'open', PChar(Address), '', '', SW_SHOW);
end;



end.
