{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit LStatSurfrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls,
  Db, DBTables, Grids, DBGrids, ExtCtrls,
  DBCtrls, Mask;

type
  TStatSurGoForm = class(TForm)
    StatsgoBtn: TSpeedButton;
    ActivateDbBtn: TSpeedButton;
    CompDS: TDataSource;
    CompTable: TTable;
    StatsgoDBName: TDatabase;
    CompRG: TRadioGroup;
    PageControl1: TPageControl;
    Components: TTabSheet;
    Label5: TLabel;
    DBEdit1: TDBEdit;
    Label4: TLabel;
    DBEdit2: TDBEdit;
    Label7: TLabel;
    DBEdit4: TDBEdit;
    Label8: TLabel;
    DBEdit5: TDBEdit;
    Label9: TLabel;
    DBEdit6: TDBEdit;
    Label10: TLabel;
    DBEdit7: TDBEdit;
    Label11: TLabel;
    DBEdit8: TDBEdit;
    Label12: TLabel;
    DBEdit9: TDBEdit;
    Label13: TLabel;
    DBEdit10: TDBEdit;
    Label14: TLabel;
    DBEdit11: TDBEdit;
    Label15: TLabel;
    DBEdit12: TDBEdit;
    Label16: TLabel;
    DBEdit13: TDBEdit;
    Label17: TLabel;
    DBEdit14: TDBEdit;
    CompWaterTS: TTabSheet;
    DBEdit15: TDBEdit;
    Label18: TLabel;
    Label19: TLabel;
    DBEdit16: TDBEdit;
    DBEdit18: TDBEdit;
    Label21: TLabel;
    DBEdit17: TDBEdit;
    Label20: TLabel;
    Label22: TLabel;
    DBEdit19: TDBEdit;
    Label23: TLabel;
    DBEdit20: TDBEdit;
    Label24: TLabel;
    DBEdit21: TDBEdit;
    Label25: TLabel;
    DBEdit22: TDBEdit;
    Label26: TLabel;
    DBEdit23: TDBEdit;
    Label27: TLabel;
    DBEdit24: TDBEdit;
    Label28: TLabel;
    DBEdit25: TDBEdit;
    Label29: TLabel;
    DBEdit26: TDBEdit;
    Label30: TLabel;
    DBEdit27: TDBEdit;
    Label31: TLabel;
    DBEdit28: TDBEdit;
    Label32: TLabel;
    DBEdit29: TDBEdit;
    Label33: TLabel;
    DBEdit30: TDBEdit;
    Label34: TLabel;
    DBEdit31: TDBEdit;
    Label35: TLabel;
    DBEdit32: TDBEdit;
    CompRockTS: TTabSheet;
    Label36: TLabel;
    DBEdit33: TDBEdit;
    Label37: TLabel;
    DBEdit34: TDBEdit;
    Label38: TLabel;
    DBEdit35: TDBEdit;
    Label39: TLabel;
    DBEdit36: TDBEdit;
    Label40: TLabel;
    DBEdit37: TDBEdit;
    Label41: TLabel;
    DBEdit38: TDBEdit;
    Label42: TLabel;
    DBEdit39: TDBEdit;
    Label43: TLabel;
    DBEdit40: TDBEdit;
    Label44: TLabel;
    DBEdit41: TDBEdit;
    Label45: TLabel;
    DBEdit42: TDBEdit;
    Label46: TLabel;
    DBEdit43: TDBEdit;
    Label47: TLabel;
    DBEdit44: TDBEdit;
    Label48: TLabel;
    DBEdit45: TDBEdit;
    Label49: TLabel;
    DBEdit46: TDBEdit;
    Label50: TLabel;
    DBEdit47: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    MapUnitDS: TDataSource;
    MapUnitTable: TTable;
    DBEdit53: TDBEdit;
    Label56: TLabel;
    DBEdit52: TDBEdit;
    Label55: TLabel;
    DBEdit51: TDBEdit;
    Label54: TLabel;
    DBEdit50: TDBEdit;
    Label53: TLabel;
    DBEdit49: TDBEdit;
    Label52: TLabel;
    DBEdit48: TDBEdit;
    Label51: TLabel;
    Label57: TLabel;
    DBEdit54: TDBEdit;
    Label58: TLabel;
    DBEdit55: TDBEdit;
    Label59: TLabel;
    DBEdit56: TDBEdit;
    Label60: TLabel;
    DBEdit57: TDBEdit;
    Label61: TLabel;
    DBEdit58: TDBEdit;
    DBEdit59: TDBEdit;
    Label62: TLabel;
    Label63: TLabel;
    DBEdit60: TDBEdit;
    Label64: TLabel;
    DBEdit61: TDBEdit;
    Label65: TLabel;
    DBEdit62: TDBEdit;
    woodlandT: TTable;
    WoodlandDS: TDataSource;
    PlantTS: TTabSheet;
    Label66: TLabel;
    DBEdit63: TDBEdit;
    Label67: TLabel;
    DBEdit64: TDBEdit;
    Label68: TLabel;
    DBEdit65: TDBEdit;
    Label69: TLabel;
    DBEdit66: TDBEdit;
    Label70: TLabel;
    DBEdit67: TDBEdit;
    Label71: TLabel;
    DBEdit68: TDBEdit;
    Label72: TLabel;
    DBEdit69: TDBEdit;
    woodmgtDS: TDataSource;
    woodmgtT: TTable;
    forestDS: TDataSource;
    forestT: TTable;
    Label82: TLabel;
    DBEdit79: TDBEdit;
    Label83: TLabel;
    DBEdit80: TDBEdit;
    Label84: TLabel;
    DBEdit81: TDBEdit;
    Label85: TLabel;
    DBEdit82: TDBEdit;
    Label86: TLabel;
    DBEdit83: TDBEdit;
    wlhabitDS: TDataSource;
    wlhabitT: TTable;
    SoilTS: TTabSheet;
    HabitMgt: TTabSheet;
    DBEdit70: TDBEdit;
    Label73: TLabel;
    Label74: TLabel;
    DBEdit71: TDBEdit;
    Label75: TLabel;
    DBEdit72: TDBEdit;
    Label76: TLabel;
    DBEdit73: TDBEdit;
    Label77: TLabel;
    DBEdit74: TDBEdit;
    Label78: TLabel;
    DBEdit75: TDBEdit;
    Label79: TLabel;
    DBEdit76: TDBEdit;
    DBEdit89: TDBEdit;
    Label92: TLabel;
    DBEdit88: TDBEdit;
    Label91: TLabel;
    DBEdit87: TDBEdit;
    Label90: TLabel;
    DBEdit86: TDBEdit;
    Label89: TLabel;
    DBEdit85: TDBEdit;
    Label88: TLabel;
    DBEdit84: TDBEdit;
    Label87: TLabel;
    Label93: TLabel;
    DBEdit90: TDBEdit;
    Label94: TLabel;
    DBEdit91: TDBEdit;
    Label95: TLabel;
    DBEdit92: TDBEdit;
    Label96: TLabel;
    DBEdit93: TDBEdit;
    Label97: TLabel;
    DBEdit94: TDBEdit;
    Label98: TLabel;
    DBEdit95: TDBEdit;
    DBEdit98: TDBEdit;
    Label101: TLabel;
    DBEdit97: TDBEdit;
    Label100: TLabel;
    DBEdit96: TDBEdit;
    Label99: TLabel;
    DBEdit77: TDBEdit;
    Label80: TLabel;
    DBEdit78: TDBEdit;
    Label81: TLabel;
    plantcomDS: TDataSource;
    plantcomT: TTable;
    plantnmDS: TDataSource;
    plantnmT: TTable;
    windbrkDS: TDataSource;
    windbrkT: TTable;
    DBEdit99: TDBEdit;
    Label102: TLabel;
    Label103: TLabel;
    DBEdit100: TDBEdit;
    Label104: TLabel;
    DBEdit101: TDBEdit;
    Label105: TLabel;
    DBEdit102: TDBEdit;
    Label106: TLabel;
    DBEdit103: TDBEdit;
    Label107: TLabel;
    DBEdit104: TDBEdit;
    Label108: TLabel;
    DBEdit105: TDBEdit;
    Label109: TLabel;
    DBEdit106: TDBEdit;
    DBEdit111: TDBEdit;
    Label114: TLabel;
    DBEdit110: TDBEdit;
    Label113: TLabel;
    DBEdit109: TDBEdit;
    Label112: TLabel;
    DBEdit108: TDBEdit;
    Label111: TLabel;
    DBEdit107: TDBEdit;
    Label110: TLabel;
    reprodDS: TDataSource;
    rsprodT: TTable;
    Label115: TLabel;
    DBEdit112: TDBEdit;
    Label116: TLabel;
    DBEdit113: TDBEdit;
    Label117: TLabel;
    DBEdit114: TDBEdit;
    Label118: TLabel;
    DBEdit115: TDBEdit;
    Label119: TLabel;
    DBEdit116: TDBEdit;
    Label120: TLabel;
    DBEdit117: TDBEdit;
    Label121: TLabel;
    DBEdit118: TDBEdit;
    Label122: TLabel;
    DBEdit119: TDBEdit;
    interpT: TTable;
    taxclassT: TTable;
    compyldT: TTable;
    yldunitsT: TTable;
    interpDS: TDataSource;
    taxclassDS: TDataSource;
    compyldDS: TDataSource;
    yldunitsDS: TDataSource;
    Label123: TLabel;
    DBEdit120: TDBEdit;
    Label124: TLabel;
    DBEdit121: TDBEdit;
    Label125: TLabel;
    DBEdit122: TDBEdit;
    Label126: TLabel;
    DBEdit123: TDBEdit;
    Label127: TLabel;
    DBEdit124: TDBEdit;
    Label128: TLabel;
    DBEdit125: TDBEdit;
    Label129: TLabel;
    DBEdit126: TDBEdit;
    Label130: TLabel;
    DBEdit127: TDBEdit;
    Label131: TLabel;
    DBEdit128: TDBEdit;
    Label132: TLabel;
    DBEdit129: TDBEdit;
    Label133: TLabel;
    DBEdit130: TDBEdit;
    Label134: TLabel;
    DBEdit131: TDBEdit;
    Label135: TLabel;
    DBEdit132: TDBEdit;
    Label136: TLabel;
    DBEdit133: TDBEdit;
    Label137: TLabel;
    DBEdit134: TDBEdit;
    Label138: TLabel;
    DBEdit135: TDBEdit;
    Label139: TLabel;
    DBEdit136: TDBEdit;
    Label140: TLabel;
    DBEdit137: TDBEdit;
    Label141: TLabel;
    DBEdit138: TDBEdit;
    Label142: TLabel;
    DBEdit139: TDBEdit;
    Label143: TLabel;
    DBEdit140: TDBEdit;
    Label144: TLabel;
    DBEdit141: TDBEdit;
    Label145: TLabel;
    DBEdit142: TDBEdit;
    Label146: TLabel;
    DBEdit143: TDBEdit;
    Label147: TLabel;
    DBEdit144: TDBEdit;
    Label148: TLabel;
    DBEdit145: TDBEdit;
    Label149: TLabel;
    DBEdit146: TDBEdit;
    layerDS: TDataSource;
    layerT: TTable;
    Layer2: TTabSheet;
    Label191: TLabel;
    DBEdit189: TDBEdit;
    DBEdit190: TDBEdit;
    Label193: TLabel;
    DBEdit191: TDBEdit;
    DBEdit192: TDBEdit;
    Label195: TLabel;
    DBEdit193: TDBEdit;
    DBEdit194: TDBEdit;
    Label197: TLabel;
    DBEdit195: TDBEdit;
    DBEdit196: TDBEdit;
    Label199: TLabel;
    DBEdit197: TDBEdit;
    DBEdit198: TDBEdit;
    Label201: TLabel;
    DBEdit199: TDBEdit;
    DBEdit200: TDBEdit;
    Label203: TLabel;
    DBEdit201: TDBEdit;
    DBEdit202: TDBEdit;
    Label205: TLabel;
    DBEdit203: TDBEdit;
    DBEdit204: TDBEdit;
    Label207: TLabel;
    DBEdit205: TDBEdit;
    DBEdit206: TDBEdit;
    Label209: TLabel;
    DBEdit207: TDBEdit;
    DBEdit208: TDBEdit;
    Label211: TLabel;
    DBEdit209: TDBEdit;
    StaMuidEdit: TEdit;
    MapTS: TTabSheet;
    MapSelectionRG: TRadioGroup;
    SpeedButton1: TSpeedButton;
    DBEdit179: TDBEdit;
    DBEdit178: TDBEdit;
    Label180: TLabel;
    DBEdit177: TDBEdit;
    DBEdit176: TDBEdit;
    Label178: TLabel;
    Label3: TLabel;
    DBEdit166: TDBEdit;
    DBEdit167: TDBEdit;
    Label170: TLabel;
    DBEdit168: TDBEdit;
    DBEdit169: TDBEdit;
    Label172: TLabel;
    DBEdit170: TDBEdit;
    DBEdit171: TDBEdit;
    Label174: TLabel;
    DBEdit172: TDBEdit;
    DBEdit173: TDBEdit;
    DBEdit174: TDBEdit;
    Label176: TLabel;
    DBEdit175: TDBEdit;
    DBEdit165: TDBEdit;
    DBEdit164: TDBEdit;
    Label167: TLabel;
    DBEdit163: TDBEdit;
    DBEdit162: TDBEdit;
    Label165: TLabel;
    DBEdit160: TDBEdit;
    DBEdit161: TDBEdit;
    Label164: TLabel;
    Label163: TLabel;
    DBEdit159: TDBEdit;
    DBEdit158: TDBEdit;
    Label161: TLabel;
    DBEdit3: TDBEdit;
    Label6: TLabel;
    DBEdit151: TDBEdit;
    Label154: TLabel;
    DBEdit184: TDBEdit;
    Label186: TLabel;
    DBEdit180: TDBEdit;
    Label182: TLabel;
    DBEdit155: TDBEdit;
    Label158: TLabel;
    DBEdit153: TDBEdit;
    DBEdit154: TDBEdit;
    Label157: TLabel;
    Label156: TLabel;
    DBEdit152: TDBEdit;
    Label155: TLabel;
    DBEdit188: TDBEdit;
    Label190: TLabel;
    SoilLayerRG: TRadioGroup;
    Label150: TLabel;
    Label151: TLabel;
    HelClassDS: TDataSource;
    InclusnDS: TDataSource;
    MucoacreDS: TDataSource;
    MuyldDS: TDataSource;
    RangenmDS: TDataSource;
    SsacoacDS: TDataSource;
    SsareaDS: TDataSource;
    HydcompDS: TDataSource;
    MuidentDS: TDataSource;
    HelClassTable: TTable;
    InclusnTable: TTable;
    MucoacreTable: TTable;
    MuyldTable: TTable;
    RangenmTable: TTable;
    SsacoacTable: TTable;
    SsareaTable: TTable;
    HydcompTable: TTable;
    MuidentTable: TTable;
    DBEdit147: TDBEdit;
    DBEdit148: TDBEdit;
    DBEdit149: TDBEdit;
    DBEdit150: TDBEdit;
    DBEdit211: TDBEdit;
    DBEdit210: TDBEdit;
    DBEdit212: TDBEdit;
    Label152: TLabel;
    Label153: TLabel;
    Label159: TLabel;
    DBFileEdit: TEdit;
    DBFileBtn: TSpeedButton;
    StatsgoHelp: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure StatsgoHelpClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActivateDbBtnClick(Sender: TObject);
    procedure DEActivateDatabase;
    procedure ActivateDatabase;    
    procedure CompRGClick(Sender: TObject);
    procedure SoilLayerRGClick(Sender: TObject);
procedure SetSoilLayer;
    procedure DBFileBtnClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  StatSurGoForm: TStatSurGoForm;
  MyAliasCount, CompSeq: Integer;

implementation

uses AllShapeLoaderFrm, LoGlobals;

{$R *.DFM}

(******************************************************************)

procedure TStatSurGoForm.StatsgoHelpClick(Sender: TObject);
begin
  Application.HelpContext(7000);
end;

procedure TStatSurGoForm.FormCreate(Sender: TObject);
begin
  MyAliasCount := 1;
  top := SoilsfrmY;
  left := SoilsfrmX;
Width:=538;
Height:=382;
end;

procedure TStatSurGoForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
{Close database if Active}
  if bSDatabaseActive then begin
    StatsgoDBName.Session.KeepConnections := False;
    StatsgoDBName.Connected := False;
    SoilsfrmY := StatSurGoForm.top;
    SoilsfrmX := StatSurGoForm.left;
  end;
end;
(******************************************************************)
procedure TStatSurGoForm.DBFileBtnClick(Sender: TObject);
begin
{  DLGOpenDialog.Filter := 'Statsgo,Surgo Shape file(*.shp)|*.shp;*.*';
  DLGOpenDialog.InitialDir := ShapePath;
  if DLGOpenDialog.execute then
  begin
    StateStatsgoShapeStr := DLGOpenDialog.Filename;
    StatsgoShapeEdit.Text := ExtractFileName(StateStatsgoShapeStr);
    ShapePath := ExtractFilePath(StateStatsgoShapeStr);
  end;}
end;
(*
    comp_dbTable,  interp_dbTable,
    compyld_dbTable, rsprod_dbTable,
    forest_dbTable,  woodland_dbTable, plantcom_dbTable,
    windbrk_dbTable,  wlhabit_dbTable,   woodmgt_dbTable,
    layer_dbTable,
    plantnm_dbTable,yldunits_dbTable,taxclass_dbTable,
{STATSGO only}  state_dbTable,
mapunit_dbTable {both?},
{SSURGO only}
  helclass_dbTable, inclusn_dbTable,
  mucoacre_dbTable, muyld_dbTable,
  rangenm_dbTable, ssacoac_dbTable, ssarea_dbTable,
  hydcomp_dbTable{?}, muident_dbTable{?}: TTable;
  *)
procedure TStatSurGoForm.ActivateDbBtnClick(Sender: TObject);
var
  bDatabaseTable: Boolean;
  ShapeSoilName, ShapeSoilPath, TempFileName: string;
begin
  if (not (bSDatabaseActive)) then
  begin
    bSDatabaseActive := False;
    bDatabaseTable := True;
{Get the database names etc..}
    if LayersLoaded > 0 then
    begin
      TempFileName :=LayA[CurrentLayer].Path+ LayA[CurrentLayer].Filename;

          if ((bStatsGOGO)) then
          begin
            DBEdit47.DataSource := CompDS;
            DBEdit47.DataField := 'PRIMFML';
          end else
          if ((bSSatsGOGO)) then
          begin
              DBEdit47.DataSource := nil;{CompDS;}
              DBEdit47.DataField := '';
          end;
{      if (bNatsGOGO) then
      begin
        ShapeSoilPath := ExtractFilePath(TempFileName);
        temp := ExtractFileName(TempFileName);
        temp2 := '  ';
        temp2[1] := temp[1];
        temp2[2] := temp[2];
        ShapeSoilPath := ShapeSoilPath + temp2;
        ShapeSoilName := ShapeSoilPath + '_comp' + '.db';
        temp2 := Uppercase(ExtractFileName(TempFileName));
        temp2 := temp2[4];
        if (temp2 = 'U') then bHYDRO := True
        else if (temp2 = 'I') then bFIPS := True
        else bMLRA := True;
      end else}
      if (bStatsGOGO) then
      begin
        ShapeSoilPath :=
        copy(TempFileName, 1, (length(TempFileName)- 4));
        ShapeSoilName := ShapeSoilPath + '_comp' + '.db';
      end else
      begin
        ShapeSoilPath := ExtractFilePath(TempFileName);
        ShapeSoilPath := ShapeSoilPath + 'Ss';
        ShapeSoilName := ShapeSoilPath + '_comp' + '.db';
      end;
      if (FileExists(ShapeSoilName)) then
      begin
            DBFileEdit.Text:=ExtractFileName(ShapeSoilName);
        try
          with StatsgoDBName.Session do
          begin
            ConfigMode := cmSession;
            try
              AddStandardAlias('StatsgoDBAlias' +
                IntToStr(MyAliasCount),
                ExtractFilePath(ShapeSoilName), 'PARADOX');
              inc(MyAliasCount);
            finally
              ConfigMode := cmAll;
            end; {finally}
            StatsgoDBName.Session.KeepConnections := True;
          end; {Session}
  {if the table exists open it on creation}
{  StatsgoDBName.DataBaseName:='StatsgoDBName';}

          DeactivateDatabase; {Resets ALL to NOT connected}


          if ((bSSatsGOGO = TRUE) or (bStatsGOGO = TRUE)) then
          begin
            ShapeSoilName := ShapeSoilPath + '_mapunit' + '.db';
            if (FileExists(ShapeSoilName)) then
            begin
              MapUnitTable.Active := False;
              MapUnitTable.TableName := ShapeSoilName;
              MapUnitTable.Active := True;
            end else bDatabaseTable := false;
          end;

          ShapeSoilName := ShapeSoilPath + '_comp' + '.db';
          if (FileExists(ShapeSoilName)) then
          begin
            CompTable.Active := False;
            CompTable.TableName := ShapeSoilName;
            CompTable.Active := True;
          end else bDatabaseTable := false;

          ShapeSoilName := ShapeSoilPath + '_forest' + '.db';
          if (FileExists(ShapeSoilName)) then
          begin
            forestT.Active := False;
            forestT.TableName := ShapeSoilName;
            forestT.Active := True;
          end else bDatabaseTable := false;

          ShapeSoilName := ShapeSoilPath + '_woodland' + '.db';
          if (FileExists(ShapeSoilName)) then
          begin
            woodlandT.Active := False;
            woodlandT.TableName := ShapeSoilName;
            woodlandT.Active := True;
          end else bDatabaseTable := false;

          ShapeSoilName := ShapeSoilPath + '_windbrk' + '.db';
          if (FileExists(ShapeSoilName)) then
          begin
            windbrkT.Active := False;
            windbrkT.TableName := ShapeSoilName;
            windbrkT.Active := True;
          end else bDatabaseTable := false;

          ShapeSoilName := ShapeSoilPath + '_plantcom' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            plantcomT.Active := False;
            plantcomT.TableName := ShapeSoilName;
            plantcomT.Active := True;
          end else bDatabaseTable := false;

          ShapeSoilName := ShapeSoilPath + '_plantnm' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            plantnmT.Active := False;
            plantnmT.TableName := ShapeSoilName;
            plantnmT.Active := True;
          end else bDatabaseTable := false;

          ShapeSoilName := ShapeSoilPath + '_wlhabit' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            wlhabitT.Active := False;
            wlhabitT.TableName := ShapeSoilName;
            wlhabitT.Active := True;
          end else bDatabaseTable := false;

          ShapeSoilName := ShapeSoilPath + '_woodmgt' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            woodmgtT.Active := False;
            woodmgtT.TableName := ShapeSoilName;
            woodmgtT.Active := True;
          end else bDatabaseTable := false;

          ShapeSoilName := ShapeSoilPath + '_compyld' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            compyldT.Active := False;
            compyldT.TableName := ShapeSoilName;
            compyldT.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_yldunits' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            yldunitsT.Active := False;
            yldunitsT.TableName := ShapeSoilName;
            yldunitsT.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_rsprod' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            rsprodT.Active := False;
            rsprodT.TableName := ShapeSoilName;
            rsprodT.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_interp' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            interpT.Active := False;
            interpT.TableName := ShapeSoilName;
            interpT.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_taxclass' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            taxclassT.Active := False;
            taxclassT.TableName := ShapeSoilName;
            taxclassT.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_layer' + '.db';
          if (FileExists(ShapeSoilName)) then
          begin
          Showmessage(ShapeSoilName);
            layerT.Active := False;
            layerT.TableName := ShapeSoilName;
            layerT.Active := True;
          end else bDatabaseTable := false;

          if ((bSSatsGOGO = TRUE) {SSURGO Only}) then
          begin
          ShapeSoilName := ShapeSoilPath + '_helclass' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            HelClassTable.Active := False;
            HelClassTable.TableName := ShapeSoilName;
            HelClassTable.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_inclusn' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            InclusnTable.Active := False;
            InclusnTable.TableName := ShapeSoilName;
            InclusnTable.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_mucoacre' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            MucoacreTable.Active := False;
            MucoacreTable.TableName := ShapeSoilName;
            MucoacreTable.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_muyld' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            MuyldTable.Active := False;
            MuyldTable.TableName := ShapeSoilName;
            MuyldTable.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_rangenm' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            RangenmTable.Active := False;
            RangenmTable.TableName := ShapeSoilName;
            RangenmTable.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_ssacoac' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            SsacoacTable.Active := False;
            SsacoacTable.TableName := ShapeSoilName;
            SsacoacTable.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_ssarea' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            SsareaTable.Active := False;
            SsareaTable.TableName := ShapeSoilName;
            SsareaTable.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_hydcomp' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            HydcompTable.Active := False;
            HydcompTable.TableName := ShapeSoilName;
            HydcompTable.Active := True;
          end else bDatabaseTable := false;
          ShapeSoilName := ShapeSoilPath + '_muident' + '.db';
          if (FileExists(ShapeSoilName)) then begin
            MuidentTable.Active := False;
            MuidentTable.TableName := ShapeSoilName;
            MuidentTable.Active := True;
          end else bDatabaseTable := false;
          end;{SSSURGO ONLY}

(*
 comp_dbTable,
forest_dbTable, woodland_dbTable, windbrk_dbTable,
                plantcom_dbTable, plantnm_dbTable,
wlhabit_dbTable, woodmgt_dbTable,
compyld_dbTable, yldunits_dbTable,
rsprod_dbTable, {rangenm}
interp_dbTable, taxclass_dbTable, {CODES} layer_dbTable,

{STATSGO only} mapunit_dbTable, {state_dbTable,}
{SSURGO only}
helclass_dbTable, inclusn_dbTable, mucoacre_dbTable, muyld_dbTable,
rangenm_dbTable, ssacoac_dbTable, ssarea_dbTable,
hydcomp_dbTable, muident_dbTable  :TTable;*)


          if (bDatabaseTable = true) then
             bSDatabaseActive := true;
          if (bDatabaseTable = true) then
          begin
            ActivateDatabase;
  {Reset to 0 = 1 so no matter what there is something there}
CompRG.ItemIndex:=0;
SoilLayerRG.ItemIndex:=0;
          end;
        finally
          if (bSDatabaseActive = false) then
          begin
    {Delete and inactive all}
            ShowMessage('Databases not found... Closing');
            StatsgoDBName.Connected := False;
            StatSurGoForm.Close;
          end;
        end; {finally}
      end else {File exists make DB}
      ShowMessage('Databases not found'
      +#13#10+ShapeSoilName+' ... Closing');
    end; {lyrs}
  end; {If active}
end; {This}
(******************************************************************)
(*
    comp_dbTable,  interp_dbTable,
    compyld_dbTable, rsprod_dbTable,
    forest_dbTable,  woodland_dbTable, plantcom_dbTable,
    windbrk_dbTable,  wlhabit_dbTable,   woodmgt_dbTable,
    layer_dbTable,
    plantnm_dbTable,yldunits_dbTable,taxclass_dbTable,
{STATSGO only}  state_dbTable,
mapunit_dbTable {both?},
{SSURGO only}
  helclass_dbTable, inclusn_dbTable,
  mucoacre_dbTable, muyld_dbTable,
  rangenm_dbTable, ssacoac_dbTable, ssarea_dbTable,
  hydcomp_dbTable{?}, muident_dbTable{?}: TTable;
*)
(******************************************************************)

procedure TStatSurGoForm.DEActivateDatabase;
begin
  if (MapUnitTable.Active = TRUE) then MapUnitTable.Active := False;

  if (CompTable.Active = TRUE) then CompTable.Active := False;
  CompTable.DisableControls;
  CompTable.MasterFields := ''; {MUID}
  CompTable.IndexFieldNames := ''; {MUID}
  CompTable.MasterSource := nil; {nil  MapUnitDS CompDS}
{CompTable.Active:=True;}
  CompTable.EnableControls;

  if (layerT.Active = TRUE) then layerT.Active := False;
{layerT}
  layerT.DisableControls;
  layerT.MasterFields := ''; {MUID;SEQNUMS MUID}
  layerT.IndexFieldNames := ''; {MUID;SEQNUMS MUID}
  layerT.MasterSource := nil; {nil  CompDS}
{layerT.Active:=True;}
  layerT.EnableControls;

  if (taxclassT.Active = TRUE) then taxclassT.Active := False;
{taxclassT  CLASCODE to Comp}
  taxclassT.DisableControls;
  taxclassT.MasterFields := ''; {CLASCODE  MUID}
  taxclassT.IndexFieldNames := ''; {CLASCODE  MUID}
  taxclassT.MasterSource := nil; {nil  CompDS}
{taxclassT.Active:=True;}
  taxclassT.EnableControls;

  if (interpT.Active = TRUE) then interpT.Active := False;
{interpT}
  interpT.DisableControls;
  interpT.MasterFields := ''; {MUID;SEQNUMS MUID}
  interpT.IndexFieldNames := ''; {MUID;SEQNUMS MUID}
  interpT.MasterSource := nil; {nil  CompDS}
{interpT.Active:=True;}
  interpT.EnableControls;

  if (forestT.Active = TRUE) then forestT.Active := False;
{forestT}
  forestT.DisableControls;
  forestT.MasterFields := ''; {MUID;SEQNUMS MUID}
  forestT.IndexFieldNames := ''; {MUID;SEQNUMS MUID}
  forestT.MasterSource := nil; {nil  CompDS}
{forestT.Active:=True;}
  forestT.EnableControls;

  if (windbrkT.Active = TRUE) then windbrkT.Active := False;
{windbrkT}
  windbrkT.DisableControls;
  windbrkT.MasterFields := ''; {MUID;SEQNUMS MUID}
  windbrkT.IndexFieldNames := ''; {MUID;SEQNUMS MUID}
  windbrkT.MasterSource := nil; {nil  CompDS}
{windbrkT.Active:=True;}
  windbrkT.EnableControls;

  if (wlhabitT.Active = TRUE) then wlhabitT.Active := False;
{wlhabitT}
  wlhabitT.DisableControls;
  wlhabitT.MasterFields := ''; {MUID;SEQNUMS  MUID}
  wlhabitT.IndexFieldNames := ''; {MUID;SEQNUMS MUID}
  wlhabitT.MasterSource := nil; {nil  CompDS}
{wlhabitT.Active:=True;}
  wlhabitT.EnableControls;

  if (rsprodT.Active = TRUE) then rsprodT.Active := False;
{rsprodT}
  rsprodT.DisableControls;
  rsprodT.MasterFields := ''; {MUID;SEQNUMS MUID}
  rsprodT.IndexFieldNames := ''; {MUID;SEQNUMS MUID}
  rsprodT.MasterSource := nil; {nil  CompDS}
{rsprodT.Active:=True;}
  rsprodT.EnableControls;

  if (plantcomT.Active = TRUE) then plantcomT.Active := False;
{plantcomT}
  plantcomT.DisableControls;
  plantcomT.MasterFields := ''; {MUID;SEQNUMS MUID}
  plantcomT.IndexFieldNames := ''; {MUID;SEQNUMS MUID}
  plantcomT.MasterSource := nil; {nil  CompDS}
{plantcomT.Active:=True;}
  plantcomT.EnableControls;

  if (yldunitsT.Active = TRUE) then yldunitsT.Active := False;
{yldunitsT  CROPNAME to  compyldT}
  yldunitsT.DisableControls;
  yldunitsT.MasterFields := ''; {CROPNAME MUID}
  yldunitsT.IndexFieldNames := ''; {CROPNAME MUID}
  yldunitsT.MasterSource := nil; {nil compyldDS CompDS}
{yldunitsT.Active:=True;}
  yldunitsT.EnableControls;

  if (compyldT.Active = TRUE) then compyldT.Active := False;
{compyldT}
  compyldT.DisableControls;
  compyldT.MasterFields := ''; {MUID;SEQNUMS MUID}
  compyldT.IndexFieldNames := ''; {MUID;SEQNUMS MUID}
  compyldT.MasterSource := nil; {nil  CompDS}
{compyldT.Active:=True;}
  compyldT.EnableControls;

  if (woodlandT.Active = TRUE) then woodlandT.Active := False;
{woodlandT}
  woodlandT.DisableControls;
  woodlandT.MasterFields := ''; {MUID;SEQNUMS MUID}
  woodlandT.IndexFieldNames := ''; {MUID;SEQNUMS MUID}
  woodlandT.MasterSource := nil; {nil  CompDS}
{woodlandT.Active:=True;}
  woodlandT.EnableControls;

  if (woodmgtT.Active = TRUE) then woodmgtT.Active := False;
{woodmgtT}
  woodmgtT.DisableControls;
  woodmgtT.MasterFields := ''; {MUID;SEQNUMS MUID}
  woodmgtT.IndexFieldNames := ''; {MUID;SEQNUMS MUID}
  woodmgtT.MasterSource := nil; {nil  CompDS}
{woodmgtT.Active:=True;}
  woodmgtT.EnableControls;

  if (plantnmT.Active = TRUE) then plantnmT.Active := False;
{plantnmT PLANTSYM to windbrkT  plantcomT woodlandT forestT}
  plantnmT.DisableControls;
  plantnmT.MasterFields := ''; {PLANTSYM MUID}
  plantnmT.IndexFieldNames := ''; {PLANTSYM MUID}
  plantnmT.MasterSource := nil; {nil windbrkDS CompDS}
{plantnmT.Active:=True;}
  plantnmT.EnableControls;

            if ((bSSatsGOGO = TRUE) {SSURGO Only}) then
          begin
  if (HelClassTable.Active = TRUE) then HelClassTable.Active := False;
{HelClassTable MUID to Mapunit muid }
  HelClassTable.DisableControls;
  HelClassTable.MasterFields := ''; {MUID}
  HelClassTable.IndexFieldNames := ''; {MUID}
  HelClassTable.MasterSource := nil; {nil MapUnitDS CompDS}
{HelClassTable.Active:=True;}
  HelClassTable.EnableControls;

  if (InclusnTable.Active = TRUE) then InclusnTable.Active := False;
{InclusnTable MUID SEQNUMS to CompDS muid SEQNUMS}
  InclusnTable.DisableControls;
  InclusnTable.MasterFields := ''; {MUID;SEQNUMS}
  InclusnTable.IndexFieldNames := ''; {MUID;SEQNUMS}
  InclusnTable.MasterSource := nil; {nil MapUnitDS CompDS}
{InclusnTable.Active:=True;}
  InclusnTable.EnableControls;

  if (MucoacreTable.Active = TRUE) then MucoacreTable.Active := False;
{MucoacreTable MUID to Mapunit muid ..cntycode to ssacoac}
  MucoacreTable.DisableControls;
  MucoacreTable.MasterFields := ''; {MUID;CNTYCODE}
  MucoacreTable.IndexFieldNames := ''; {MUID;CNTYCODE}
  MucoacreTable.MasterSource := nil; {nil MapUnitDS CompDS ssacoac}
{MucoacreTable.Active:=True;}
  MucoacreTable.EnableControls;

  if (MuyldTable.Active = TRUE) then MuyldTable.Active := False;
{MuyldTable MUID to Mapunit muid ..CROPNAME to yldunits?}
  MuyldTable.DisableControls;
  MuyldTable.MasterFields := ''; {MUID;CROPNAME}
  MuyldTable.IndexFieldNames := ''; {MUID;CROPNAME}
  MuyldTable.MasterSource := nil; {nil MapUnitDS or CompYldDS ?}
{MuyldTable.Active:=True;}
  MuyldTable.EnableControls;

  if (RangenmTable.Active = TRUE) then RangenmTable.Active := False;
{RangenmTable RSID to RSProd ?}
  RangenmTable.DisableControls;
  RangenmTable.MasterFields := ''; {RSID}
  RangenmTable.IndexFieldNames := ''; {RSID}
  RangenmTable.MasterSource := nil; {nil MapUnitDS or RSProd ?}
{RangenmTable.Active:=True;}
  RangenmTable.EnableControls;

   if (SsacoacTable.Active = TRUE) then SsacoacTable.Active := False;
{SsacoacTable STSSAID;CNTYCODE from mucoacre}
  SsacoacTable.DisableControls;
  SsacoacTable.MasterFields := ''; {STSSAID;CNTYCODE}
  SsacoacTable.IndexFieldNames := ''; {STSSAID;CNTYCODE}
  SsacoacTable.MasterSource := nil; {nil MapUnitDS  or MucoacreDS?}
{SsacoacTable.Active:=True;}
  SsacoacTable.EnableControls;

  if (SsareaTable.Active = TRUE) then SsareaTable.Active := False;
{SsareaTable STSSAID to MapUnitDS}
  SsareaTable.DisableControls;
  SsareaTable.MasterFields := ''; {STSSAID}
  SsareaTable.IndexFieldNames := ''; {STSSAID}
  SsareaTable.MasterSource := nil; {nil MapUnitDS}
{SsareaTable.Active:=True;}
  SsareaTable.EnableControls;

  if (HydcompTable.Active = TRUE) then HydcompTable.Active := False;
{HydcompTable}
  HydcompTable.DisableControls;
  HydcompTable.MasterFields := ''; {'MUID;SEQNUMS'}
  HydcompTable.IndexFieldNames := ''; {'MUID;SEQNUMS'}
  HydcompTable.MasterSource := nil; {nil ? CompDS}
{HydcompTable.Active:=True;}
  HydcompTable.EnableControls;

  if (MuidentTable.Active = TRUE) then MuidentTable.Active := False;
{MuidentTable  does WHAT?}
  MuidentTable.DisableControls;
  MuidentTable.MasterFields := ''; {'STSSAID;MUID'}
  MuidentTable.IndexFieldNames := ''; {'STSSAID;MUID'}
  MuidentTable.MasterSource := nil; {nil MapUnitDS}
{MuidentTable.Active:=True;}
  MuidentTable.EnableControls;
          End;

  {Reset to 0 = 1 so no matter what there is something there}
CompRG.Enabled:=False;
CompRG.ItemIndex:=0;
CompRG.Enabled:=True;
SoilLayerRG.Enabled:=False;
SoilLayerRG.ItemIndex:=0;
SoilLayerRG.Enabled:=True;
end;
(******************************************************************)
(*
    comp_dbTable,  interp_dbTable,
    compyld_dbTable, rsprod_dbTable,
    forest_dbTable,  woodland_dbTable, plantcom_dbTable,
    windbrk_dbTable,  wlhabit_dbTable,   woodmgt_dbTable,
    layer_dbTable,
    plantnm_dbTable,yldunits_dbTable,taxclass_dbTable,
{STATSGO only}  state_dbTable,
mapunit_dbTable {both?},
{SSURGO only}
  helclass_dbTable, inclusn_dbTable,
  mucoacre_dbTable, muyld_dbTable,
  rangenm_dbTable, ssacoac_dbTable, ssarea_dbTable,
  hydcomp_dbTable{?}, muident_dbTable{?}: TTable;
*)
(******************************************************************)

procedure TStatSurGoForm.ActivateDatabase;
begin
  if ((bSSatsGOGO) or (bStatsGOGO)) then
    MapUnitTable.Active := False;
  if (bStatsGOGO) then
    StatSurGoForm.Caption := 'USDA NRCS STATSGO Soils'
  else if (bSSatsGOGO) then
    StatSurGoForm.Caption := 'USDA NRCS SSURGO Soils'
{  else StatSurGoForm.Caption := 'USDA NRCS NATSGO Soils'};

  CompTable.Active := False;
  layerT.Active := False;
  taxclassT.Active := False;
  interpT.Active := False;
  forestT.Active := False;
  windbrkT.Active := False;
  wlhabitT.Active := False;
  rsprodT.Active := False;
  plantcomT.Active := False;
  yldunitsT.Active := False;
  compyldT.Active := False;
  woodlandT.Active := False;
  woodmgtT.Active := False;
  plantnmT.Active := False;

    if ((bSSatsGOGO)) then
    begin
      HelClassTable.Active := False;
      InclusnTable.Active := False;
      MucoacreTable.Active := False;
      MuyldTable.Active := False;
      RangenmTable.Active := False;
      SsacoacTable.Active := False;
      SsareaTable.Active := False;
      HydcompTable.Active := False;
      MuidentTable.Active := False;
    end;

    if ((bSSatsGOGO) or (bStatsGOGO)) then
    begin
      MapUnitTable.Active := True; {MapUnitTable need nothing...}
{CompTable}
      CompTable.DisableControls;
      CompTable.MasterFields := 'MUID'; {MUID}
      CompTable.IndexFieldNames := 'MUID'; {MUID}
      CompTable.MasterSource := MapUnitDS; {nil  CompDS}
      CompTable.Active := True;
      CompTable.EnableControls;
{forestT}
      forestT.DisableControls;
      forestT.MasterFields := 'MUID;SEQNUMS'; {MUID}
      forestT.IndexFieldNames := 'MUID;SEQNUMS'; {MUID}
      forestT.MasterSource := CompDS; {nil  CompDS}
      forestT.Active := True;
      forestT.EnableControls;
{woodlandT}
      woodlandT.DisableControls;
      woodlandT.MasterFields := 'MUID;SEQNUMS'; {MUID}
      woodlandT.IndexFieldNames := 'MUID;SEQNUMS'; {MUID}
      woodlandT.MasterSource := CompDS; {nil  CompDS}
      woodlandT.Active := True;
      woodlandT.EnableControls;
{plantcomT}
      plantcomT.DisableControls;
      plantcomT.MasterFields := 'MUID;SEQNUMS'; {MUID}
      plantcomT.IndexFieldNames := 'MUID;SEQNUMS'; {MUID}
      plantcomT.MasterSource := CompDS; {nil  CompDS}
      plantcomT.Active := True;
      plantcomT.EnableControls;
{windbrkT}
      windbrkT.DisableControls;
      windbrkT.MasterFields := 'MUID;SEQNUMS'; {MUID}
      windbrkT.IndexFieldNames := 'MUID;SEQNUMS'; {MUID}
      windbrkT.MasterSource := CompDS; {nil  CompDS}
      windbrkT.Active := True;
      windbrkT.EnableControls;

{plantnmT PLANTSYM to windbrkT  plantcomT woodlandT forestT}
      plantnmT.DisableControls;
      plantnmT.MasterFields := 'PLANTSYM'; {MUID}
      plantnmT.IndexFieldNames := 'PLANTSYM'; {MUID}
      plantnmT.MasterSource := windbrkDS; {nil  CompDS}
      plantnmT.Active := True;
      plantnmT.EnableControls;

{compyldT}
      compyldT.DisableControls;
      compyldT.MasterFields := 'MUID;SEQNUMS'; {MUID}
      compyldT.IndexFieldNames := 'MUID;SEQNUMS'; {MUID}
      compyldT.MasterSource := CompDS; {nil  CompDS}
      compyldT.Active := True;
      compyldT.EnableControls;

{yldunitsT  CROPNAME to  compyldT}
      yldunitsT.DisableControls;
      yldunitsT.MasterFields := 'CROPNAME'; {MUID}
      yldunitsT.IndexFieldNames := 'CROPNAME'; {MUID}
      yldunitsT.MasterSource := compyldDS; {nil  CompDS}
      yldunitsT.Active := True;
      yldunitsT.EnableControls;

{rsprodT}
      rsprodT.DisableControls;
      rsprodT.MasterFields := 'MUID;SEQNUMS'; {MUID}
      rsprodT.IndexFieldNames := 'MUID;SEQNUMS'; {MUID}
      rsprodT.MasterSource := CompDS; {nil  CompDS}
      rsprodT.Active := True;
      rsprodT.EnableControls;

{wlhabitT}
      wlhabitT.DisableControls;
      wlhabitT.MasterFields := 'MUID;SEQNUMS'; {MUID}
      wlhabitT.IndexFieldNames := 'MUID;SEQNUMS'; {MUID}
      wlhabitT.MasterSource := CompDS; {nil  CompDS}
      wlhabitT.Active := True;
      wlhabitT.EnableControls;

{woodmgtT}
      woodmgtT.DisableControls;
      woodmgtT.MasterFields := 'MUID;SEQNUMS'; {MUID}
      woodmgtT.IndexFieldNames := 'MUID;SEQNUMS'; {MUID}
      woodmgtT.MasterSource := CompDS; {nil  CompDS}
      woodmgtT.Active := True;
      woodmgtT.EnableControls;

{interpT}
      interpT.DisableControls;
      interpT.MasterFields := 'MUID;SEQNUMS'; {MUID}
      interpT.IndexFieldNames := 'MUID;SEQNUMS'; {MUID}
      interpT.MasterSource := CompDS; {nil  CompDS}
      interpT.Active := True;
      interpT.EnableControls;

{taxclassT  CLASCODE to Comp}
      taxclassT.DisableControls;
      taxclassT.MasterFields := 'CLASCODE'; {MUID}
      taxclassT.IndexFieldNames := 'CLASCODE'; {MUID}
      taxclassT.MasterSource := CompDS; {nil  CompDS}
      taxclassT.Active := True;
      taxclassT.EnableControls;

{layerT}
      layerT.DisableControls;
      layerT.MasterFields := 'MUID;SEQNUMS'; {MUID}
      layerT.IndexFieldNames := 'MUID;SEQNUMS'; {MUID}
      layerT.MasterSource := CompDS; {nil  CompDS}
      layerT.Active := True;
      layerT.EnableControls;
    end;

            if ((bSSatsGOGO = TRUE) {SSURGO Only}) then
          begin
  if (HelClassTable.Active = TRUE) then HelClassTable.Active := False;
{HelClassTable MUID to Mapunit muid }
  HelClassTable.DisableControls;
  HelClassTable.MasterFields := 'MUID'; {MUID}
  HelClassTable.IndexFieldNames := 'MUID'; {MUID}
  HelClassTable.MasterSource := MapUnitDS; {nil MapUnitDS CompDS}
  HelClassTable.Active:=True;
  HelClassTable.EnableControls;

  if (InclusnTable.Active = TRUE) then InclusnTable.Active := False;
{InclusnTable MUID SEQNUMS to CompDS muid SEQNUMS}
  InclusnTable.DisableControls;
  InclusnTable.MasterFields := 'MUID'; {MUID;SEQNUMS}
  InclusnTable.IndexFieldNames := 'MUID'; {MUID;SEQNUMS}
  InclusnTable.MasterSource := MapUnitDS; {nil MapUnitDS CompDS}
  InclusnTable.Active:=True;
  InclusnTable.EnableControls;

  if (MucoacreTable.Active = TRUE) then MucoacreTable.Active := False;
{MucoacreTable MUID to Mapunit muid ..cntycode to ssacoac}
  MucoacreTable.DisableControls;
  MucoacreTable.MasterFields := 'MUID'; {MUID;CNTYCODE}
  MucoacreTable.IndexFieldNames := 'MUID'; {MUID;CNTYCODE}
  MucoacreTable.MasterSource := MapUnitDS; {nil MapUnitDS CompDS ssacoac}
  MucoacreTable.Active:=True;
  MucoacreTable.EnableControls;

  if (MuyldTable.Active = TRUE) then MuyldTable.Active := False;
{MuyldTable MUID to Mapunit muid ..CROPNAME to yldunits?}
  MuyldTable.DisableControls;
  MuyldTable.MasterFields := 'MUID'; {MUID;CROPNAME}
  MuyldTable.IndexFieldNames := 'MUID'; {MUID;CROPNAME}
  MuyldTable.MasterSource := MapUnitDS; {nil MapUnitDS or CompYldDS ?}
  MuyldTable.Active:=True;
  MuyldTable.EnableControls;

  if (RangenmTable.Active = TRUE) then RangenmTable.Active := False;
{RangenmTable RSID to RSProd ?}
  RangenmTable.DisableControls;
  RangenmTable.MasterFields := 'RSID'; {RSID}
  RangenmTable.IndexFieldNames := 'RSID'; {RSID}
  RangenmTable.MasterSource := reprodDS; {nil MapUnitDS or RSProd ?}
  RangenmTable.Active:=True;
  RangenmTable.EnableControls;

   if (SsacoacTable.Active = TRUE) then SsacoacTable.Active := False;
{SsacoacTable STSSAID;CNTYCODE from mucoacre}
  SsacoacTable.DisableControls;
  SsacoacTable.MasterFields := 'STSSAID'; {STSSAID;CNTYCODE}
  SsacoacTable.IndexFieldNames := 'STSSAID'; {STSSAID;CNTYCODE}
  SsacoacTable.MasterSource := MapUnitDS; {nil MapUnitDS  or MucoacreDS?}
  SsacoacTable.Active:=True;
  SsacoacTable.EnableControls;

  if (SsareaTable.Active = TRUE) then SsareaTable.Active := False;
{SsareaTable STSSAID to MapUnitDS}
  SsareaTable.DisableControls;
  SsareaTable.MasterFields := 'STSSAID'; {STSSAID}
  SsareaTable.IndexFieldNames := 'STSSAID'; {STSSAID}
  SsareaTable.MasterSource := MapUnitDS; {nil MapUnitDS}
  SsareaTable.Active:=True;
  SsareaTable.EnableControls;

  if (HydcompTable.Active = TRUE) then HydcompTable.Active := False;
{HydcompTable}
  HydcompTable.DisableControls;
  HydcompTable.MasterFields := 'MUID;SEQNUMS'; {'MUID;SEQNUMS'}
  HydcompTable.IndexFieldNames := 'MUID;SEQNUMS'; {'MUID;SEQNUMS'}
  HydcompTable.MasterSource := CompDS; {nil ? CompDS}
  HydcompTable.Active:=True;
  HydcompTable.EnableControls;

  if (MuidentTable.Active = TRUE) then MuidentTable.Active := False;
{MuidentTable  does WHAT?}
  MuidentTable.DisableControls;
  MuidentTable.MasterFields := 'STSSAID;MUID'; {'STSSAID;MUID'}
  MuidentTable.IndexFieldNames := 'STSSAID;MUID'; {'STSSAID;MUID'}
  MuidentTable.MasterSource := MapUnitDS; {nil MapUnitDS}
  MuidentTable.Active:=True;
  MuidentTable.EnableControls;
          End;

  (*
{MapUnitTable}
  if ((bNatsGOGO)) then begin
    MapUnitTable.Active := False;

    CompTable.DisableControls;
    CompTable.Active := True; {Base for NRI}
    CompTable.EnableControls;

{forestT}
    forestT.DisableControls;
    forestT.MasterFields := 'NRIPTR'; {MUID}
    forestT.IndexFieldNames := 'NRIPTR'; {MUID}
    forestT.MasterSource := CompDS; {nil  CompDS}
    forestT.Active := True;
    forestT.EnableControls;
{woodlandT}
    woodlandT.DisableControls;
    woodlandT.MasterFields := 'NRIPTR'; {MUID}
    woodlandT.IndexFieldNames := 'NRIPTR'; {MUID}
    woodlandT.MasterSource := CompDS; {nil  CompDS}
    woodlandT.Active := True;
    woodlandT.EnableControls;
{plantcomT}
    plantcomT.DisableControls;
    plantcomT.MasterFields := 'NRIPTR'; {MUID}
    plantcomT.IndexFieldNames := 'NRIPTR'; {MUID}
    plantcomT.MasterSource := CompDS; {nil  CompDS}
    plantcomT.Active := True;
    plantcomT.EnableControls;
{windbrkT}
    windbrkT.DisableControls;
    windbrkT.MasterFields := 'NRIPTR'; {MUID}
    windbrkT.IndexFieldNames := 'NRIPTR'; {MUID}
    windbrkT.MasterSource := CompDS; {nil  CompDS}
    windbrkT.Active := True;
    windbrkT.EnableControls;

{plantnmT PLANTSYM to windbrkT  plantcomT woodlandT forestT}
    plantnmT.DisableControls;
    plantnmT.MasterFields := 'PLANTSYM'; {MUID}
    plantnmT.IndexFieldNames := 'PLANTSYM'; {MUID}
    plantnmT.MasterSource := windbrkDS; {nil  CompDS}
    plantnmT.Active := True;
    plantnmT.EnableControls;

{compyldT}
    compyldT.DisableControls;
    compyldT.MasterFields := 'NRIPTR'; {MUID}
    compyldT.IndexFieldNames := 'NRIPTR'; {MUID}
    compyldT.MasterSource := CompDS; {nil  CompDS}
    compyldT.Active := True;
    compyldT.EnableControls;

{yldunitsT  CROPNAME to  compyldT}
    yldunitsT.DisableControls;
    yldunitsT.MasterFields := 'CROPNAME'; {MUID}
    yldunitsT.IndexFieldNames := 'CROPNAME'; {MUID}
    yldunitsT.MasterSource := compyldDS; {nil  CompDS}
    yldunitsT.Active := True;
    yldunitsT.EnableControls;

{rsprodT}
    rsprodT.DisableControls;
    rsprodT.MasterFields := 'NRIPTR'; {MUID}
    rsprodT.IndexFieldNames := 'NRIPTR'; {MUID}
    rsprodT.MasterSource := CompDS; {nil  CompDS}
    rsprodT.Active := True;
    rsprodT.EnableControls;

{wlhabitT}
    wlhabitT.DisableControls;
    wlhabitT.MasterFields := 'NRIPTR'; {MUID}
    wlhabitT.IndexFieldNames := 'NRIPTR'; {MUID}
    wlhabitT.MasterSource := CompDS; {nil  CompDS}
    wlhabitT.Active := True;
    wlhabitT.EnableControls;

{woodmgtT}
    woodmgtT.DisableControls;
    woodmgtT.MasterFields := 'NRIPTR'; {MUID}
    woodmgtT.IndexFieldNames := 'NRIPTR'; {MUID}
    woodmgtT.MasterSource := CompDS; {nil  CompDS}
    woodmgtT.Active := True;
    woodmgtT.EnableControls;

{interpT}
    interpT.DisableControls;
    interpT.MasterFields := 'NRIPTR'; {MUID}
    interpT.IndexFieldNames := 'NRIPTR'; {MUID}
    interpT.MasterSource := CompDS; {nil  CompDS}
    interpT.Active := True;
    interpT.EnableControls;

{taxclassT  CLASCODE to Comp}
    taxclassT.DisableControls;
    taxclassT.MasterFields := 'CLASCODE'; {MUID}
    taxclassT.IndexFieldNames := 'CLASCODE'; {MUID}
    taxclassT.MasterSource := CompDS; {nil  CompDS}
    taxclassT.Active := True;
    taxclassT.EnableControls;

{layerT}
    layerT.DisableControls;
    layerT.MasterFields := 'NRIPTR'; {MUID}
    layerT.IndexFieldNames := 'NRIPTR'; {MUID}
    layerT.MasterSource := CompDS; {nil  CompDS}
    layerT.Active := True;
    layerT.EnableControls;
  end else
*)
end;
(******************************************************************)
(******************************************************************)


(******************************************************************)
(******************************************************************)
{Query Map from MAIN using Mouse
to return a Map Unit ID MUID  of a Polygon
 to then select into the database}

procedure TStatSurGoForm.CompRGClick(Sender: TObject);
var TempSS, temp, temp2: string;
begin
  if (((bStatsGOGO)) and bSDatabaseActive) then
  begin
    CompSeq := CompRG.ItemIndex + 1;
    str(CompSeq, temp2);
    temp := StaMuidEdit.Text + ';' + temp2;
    MapUnitTable.Locate('MUID', StaMuidEdit.Text, []);
    temp := '[SEQNUM] = ' + temp2;
  {Reset to 0 = 1 so no matter what there is something there}
{CompRG.ItemIndex:=CompSeq-1;
SoilLayerRG.ItemIndex:=0;
CompRG.Enabled:=False;
CompRG.ItemIndex:=0;
CompRG.Enabled:=True;
SoilLayerRG.Enabled:=False;
SoilLayerRG.ItemIndex:=0;
SoilLayerRG.Enabled:=True;}
    CompTable.Filtered := False;
    CompTable.Filter := temp;
    CompTable.Filtered := True;
    MuidFound := False;
  end;
  if (((bSSatsGOGO)) and bSDatabaseActive) then
  begin
    CompSeq := CompRG.ItemIndex + 1;
    TempSS := MapUnitTable.FieldByName('ssaid').AsString;
    MapUnitTable.Locate('MUID', TempSS + StaMuidEdit.Text, []);
    str(CompSeq, temp2);
    temp := '[SEQNUMS] = ' + temp2
      {+ ') AND ([MUID] = '+StaMuidEdit.Text+'))'};
{    DeActivateDatabase;}
  {Reset to 0 = 1 so no matter what there is something there}
{CompRG.Enabled:=False;
CompRG.ItemIndex:=CompSeq-1;
CompRG.Enabled:=True;}
    CompTable.Filtered := False;
    CompTable.Filter := temp;
    CompTable.Filtered := True;
{SoilLayerRG.Enabled:=False;
SoilLayerRG.ItemIndex:=0;
SoilLayerRG.Enabled:=True;
SetSoilLayer;}
{    layerT.Filtered := False;
    layerT.Filter := temp;
    layerT.Filtered := True;}

{    ActivateDatabase;}
    MuidFound := False;
  end;
end;
{with Table1 do
begin
  SetKey;
  FieldByName('State').AsString := 'CA';
  FieldByName('City').AsString := 'Santa';
  GotoNearest;
end;}
(******************************************************************)
procedure TStatSurGoForm.SoilLayerRGClick(Sender: TObject);
begin {SoilLayerRG}
  if (((bStatsGOGO) or (bSSatsGOGO)) and bSDatabaseActive) then
  SetSoilLayer;
end;

procedure TStatSurGoForm.SetSoilLayer;
var
temp, temp2: string;
SoilLayerI: Integer;
  begin
    SoilLayerI := SoilLayerRG.ItemIndex + 1;
      {MapUnitTable.Locate('MUID',StaMuidEdit.Text,[]);}
    str(SoilLayerI, temp2);
    temp := '[LAYERNUM] = ' + temp2;
    layerT.Filtered := False;
    layerT.Filter := temp;
    layerT.Filtered := True;
  end;
(******************************************************************)


(******************************************************************)





procedure TStatSurGoForm.SpeedButton2Click(Sender: TObject);
var  strItem2S,TempSS:String;
begin
if (bSSatsGOGO) then
begin
TempSS :=
StatSurGoForm.MapUnitTable.FieldByName('ssaid').AsString;
strItem2S:=StatSurGoForm.StaMuidEdit.Text;
StatSurGoForm.MapUnitTable.Locate('MUID', TempSS +strItem2S, []);
end else
begin
strItem2S:=(StatSurGoForm.StaMuidEdit.Text);
StatSurGoForm.MapUnitTable.Locate('MUID', strItem2S,[]);
end;
end;

end.
